package fr.aminelouveaau.cartes;

import fr.aminelouveaau.cartes.model.Number;
import fr.aminelouveaau.cartes.model.Shape;
import fr.aminelouveaau.cartes.service.GameService;
import javafx.util.Pair;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.util.ReflectionTestUtils;

import java.util.List;

import static org.assertj.core.api.AssertionsForClassTypes.assertThat;

@SpringBootTest
class CartesApplicationTests {

    @InjectMocks
    GameService gameService;

    @BeforeEach
    public void setUp() {
        ReflectionTestUtils.setField(gameService, "cardHandNumber", 10);
        gameService.init();
    }

    @Test
    void testDeckGeneration() {
        List<Pair<Shape, Number>> deck = gameService.getDeck();
        assertThat(deck.size()).isNotEqualTo(0).withFailMessage("Deck is empty");
        assertThat(deck.size()).isEqualTo(4 * 13).withFailMessage("Deck is not complete");
    }

    @Test
    void contextLoads() {
    }

}
